
* ---------------------------------------------------------------- smcrvrse
       Program smcrvrse

* One time program to time-reverse an smc file (to see if acausal
* filter gives the same result)

*  Dates:  04/18/02 - Written by D. Boore (based on SMC_PAD.FOR)
*        10/17/07 - Transparent change to user needed because smcread can
*                   read two input formats

      character precision*8


      real  rhead(50)

      integer ihead(48)

      real y(:), yr(:)
      allocatable :: y, yr

      character chead(11)*80, comments(200)*80
      character f_ctl*40, f_out*70, f_smc*40
      character buf_stop*4, buf*10
      character ctl_cmmnts(10)*80

      logical f_ctl_exist


      f_smc = ' '
      f_smc = '53qxf_a.pad'
      call trim_c(f_smc, nc_f_smc)
      write(*,'(a)') ' f_smc = '//f_smc(1:nc_f_smc)

      call smc_nsps(f_smc, npts_smc, sps)

      allocate(y(npts_smc), yr(npts_smc))

      tskip = 0.0
      tlength = -1
      call SMCRead(f_smc, tskip, tlength,
     :                   y, chead, ihead, rhead, comments)

      precision = ' '
      if (ihead(47) .eq. 8) then
        precision = 'HIGH'
      else
        precision = 'STANDARD'
      end if
      
      
* Store reverse time series:


      do i = 1, npts_smc
        yr(i) = y(npts_smc - i + 1)
      end do

      f_out = ' '
      f_out = '53rvra.pad'
      write(*,'(a)') ' f_out = '//f_out(1:nc_f_smc)

* Store  comments:
      ncomments = ihead(16)
      ncomments = ncomments + 1
      comments(ncomments) = '|'
      ncomments = ncomments + 1
      write(comments(ncomments),'(a)') 
     :  '| Program SMCRVRSE reversed time series '//f_smc(1:nc_f_smc)
      ncomments = ncomments + 1
      comments(ncomments) = '|'
      ihead(16) = ncomments            

* Write the output file:

      itype = -1
      call SMCWrite(f_out, precision,
     :                yr, chead, itype, 
     :                    ihead, rhead, comments)

* That should be it; deallocate the y array and loop back for another file
 
      deallocate(y, yr)

      stop
      end
* ---------------------------------------------------------------- smcrvrse


      include '\forprogs\skip.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\smcread.for'
      include '\forprogs\smcwrite.for'
      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\mnmax.for'
      include '\forprogs\mnmaxidx.for'
      include '\forprogs\smc_nsps.for'
      include '\forprogs\datetime.for'
      include '\forprogs\skipcmnt.for'


                     